/***************************************
 * 
 * js公共类 该类库依赖于mui.js
 * 
 * 
 **************************************/
;(function(window){
	var Sunjs=Sunjs||{};
	Sunjs.data=Sunjs.data||{};//当前运行参数
	Sunjs.vesion='0.0.0.1';
	Sunjs.clientId='000000';//客户端编号
	Sunjs.clientSect='000000';//验证
	Sunjs.localstorage=Sunjs.localstorage||{};//本地存储对象最大支持5M
	//登录用户信息
	Sunjs.user=function(){
		return Sunjs.getLocalStorage(localstoragekey.userinfo,'json');
	}
	//获取访问令牌
	Sunjs.token=function(){
		var _token=Sunjs.getLocalStorage(localstoragekey.token,'json');
		if(_token===null){
			Sunjs.gettoken1();
		}
		_token=Sunjs.getLocalStorage(localstoragekey.token,'json');
		return _token;
	}
	//初始化参数
	Sunjs.init=function(){
		try{
			//从存储中加载本地信息
			var _token=Sunjs.getLocalStorage(localstoragekey.token,'json');
			
			if(_token===null){
				Sunjs.gettoken1();
			}
			
		}catch(ex){
			console.log(ex);
		}
	}
	//#Id
	Sunjs.getById=function(id){
		var tmps=mui('#'+id);
		return tmps!=null?tmps[0]:undefined;
	}
	Sunjs.ReplaceEnterToBr=function(text){
		var i=0;
		while(text.indexOf("\r\n")>-1)
		{
			text=text.replace("\r\n","<br/>");
			i=i+1;
			if(i>100)
				break;
		}	
		i=0;
		while(text.indexOf("\n")>-1)
		{
			text=text.replace("\n","<br/>");
			i=i+1;
			if(i>100)
				break;
		}
		return text;
	}
	//get 返回json
	Sunjs.ajaxGet=function(url,data,callback){
		try{
			if(Sunjs.IsNet()){
				plus.nativeUI.toast('网络异常，请检查网络设置！');	
				return;
			}
			var options={
				url:url,
				dataType:config.datatype,
				type:'GET',
				async:true,
				timeout:30000,
				contentType:'application/json',
				headers:{
					'Authorization':config.bearer+' '+Sunjs.token().access_token
				},
				data:data,
				success:callback,
				error: function(xhr, type, errorThrown) {
					if(type==='timeout'){
						plus.nativeUI.toast('请求超时,稍后重试');
						return;
					}
					if(xhr.status===401){
						Sunjs.error(JSON.parse(xhr.responseText));
						Sunjs.Logout();
					}else if(xhr.status===502){
						Sunjs.error(JSON.parse(xhr.responseText));
					}else{
						var _json=JSON.parse(xhr.responseText);
						plus.nativeUI.toast(_json.error);
					}
				},
				complete:function(){
					plus.nativeUI.closeWaiting();
				}
			};
			mui.ajax(options);
		}catch(ex){
			plus.nativeUI.closeWaiting();
			console.log(ex);
		}
	}
	Sunjs.ajaxGet_wait=function(url,data,callback){
		try{
			if(Sunjs.IsNet()){
				plus.nativeUI.toast('网络异常，请检查网络设置！');	
				return;
			}
			var options={
				url:url,
				dataType:config.datatype,
				type:'GET',
				contentType:'application/json',
				headers:{
					'Authorization':config.bearer+' '+Sunjs.token().access_token
				},
				data:data,
				timeout:30000,
				success:callback,
				error: function(xhr, type, errorThrown) {
					if(type==='timeout'){
						plus.nativeUI.toast('请求超时,稍后重试');
						return;
					}
					if(xhr.status===401){
						Sunjs.error(JSON.parse(xhr.responseText));
						Sunjs.Logout();
					}else if(xhr.status===502){
						Sunjs.error(JSON.parse(xhr.responseText));
					}else{
						var _json=JSON.parse(xhr.responseText);
						plus.nativeUI.toast(_json.error);
					}
				},
				beforeSend:function(){
					plus.nativeUI.showWaiting();
				},
				complete:function(){
					plus.nativeUI.closeWaiting();
				}
			};
			mui.ajax(options);
		}catch(ex){
			plus.nativeUI.showWaiting();
			console.log(ex);
		}
		
	}
	//post
	Sunjs.ajaxPost=function(url,data,callback){
		try{
			if(Sunjs.IsNet()){
				plus.nativeUI.toast('网络异常，请检查网络设置！');	
				return;
			}
			var options={
				url:url,
				dataType:config.datatype,
				type:'POST',
				contentType:'application/json',
				headers:{
					'Authorization':config.bearer+' '+Sunjs.token().access_token
				},
				data:data,
				timeout:30000,
				success:callback,
				error: function(xhr, type, errorThrown) {
					if(type==='timeout'){
						plus.nativeUI.toast('请求超时,稍后重试');
						return;
					}
					if(xhr.status===401){
						Sunjs.error(JSON.parse(xhr.responseText));
						Sunjs.Logout();
					}else if(xhr.status===502){
						Sunjs.error(JSON.parse(xhr.responseText));
					}else{
						var _json=JSON.parse(xhr.responseText);
						plus.nativeUI.toast(_json.error);
					}
				},
				complete:function(){
					plus.nativeUI.closeWaiting();
				}
			};
			mui.ajax(options);
		}catch(ex){
			plus.nativeUI.closeWaiting();
			console.log(ex);
		}
	}
	//同步方法
	Sunjs.ajaxPost_Async=function(url,data,callback,istoken){
		try{
			if(Sunjs.IsNet()){
				plus.nativeUI.toast('网络异常，请检查网络设置！');	
				return;
			}
			var options={
				url:url,
				dataType:config.datatype,
				async:false,
				type:'POST',
				contentType:'application/json',
				data:data,
				timeout:30000,
				success:callback,
				error: function(xhr, type, errorThrown) {
					if(type==='timeout'){
						plus.nativeUI.toast('请求超时,稍后重试');
						return;
					}
					if(xhr.status===401){
						Sunjs.error(JSON.parse(xhr.responseText));
						Sunjs.Logout();
					}else if(xhr.status===502){
						Sunjs.error(JSON.parse(xhr.responseText));
					}else{
						var _json=JSON.parse(xhr.responseText);
						plus.nativeUI.toast(_json.error);
					}
				},
				complete:function(){
					plus.nativeUI.closeWaiting();
				}
			};
			if(istoken){
				options.headers={
					'Authorization':config.bearer+' '+Sunjs.token().access_token
				};
			}
			mui.ajax(options);
		}catch(ex){
			plus.nativeUI.closeWaiting();
			console.log(ex);
		}
	}
	//post 带提示框
	Sunjs.ajaxPost_wait=function(url,data,callback){
		try{
			if(Sunjs.IsNet()){
				plus.nativeUI.toast('网络异常，请检查网络设置！');	
				return;
			}
			var options={
				url:url,
				dataType:config.datatype,
				type:'POST',
				contentType:'application/json',
				headers:{
					'Authorization':config.bearer+' '+Sunjs.token().access_token
				},
				data:data,
				timeout:30000,
				success:callback,
				error: function(xhr, type, errorThrown) {
					if(type==='timeout'){
						plus.nativeUI.toast('请求超时,稍后重试');
						return;
					}
					if(xhr.status===401){
						Sunjs.error(JSON.parse(xhr.responseText));
						Sunjs.Logout();
					}else if(xhr.status===502){
						Sunjs.error(JSON.parse(xhr.responseText));
					}else{
						var _json=JSON.parse(xhr.responseText);
						plus.nativeUI.toast(_json.error);
					}
				},
				beforeSend:function(){
					plus.nativeUI.showWaiting();
				},
				complete:function(){
					plus.nativeUI.closeWaiting();
				}
			};
			mui.ajax(options);
		}catch(ex){
			plus.nativeUI.showWaiting();
			console.log(ex);
		}
	}
	//获取用户信息
	Sunjs.getuserinfo=function(callback,refresh){
		var options={
			url:url.userinfo,
			dataType:config.datatype,
			headers:{
				'Authorization':config.bearer+' '+Sunjs.token().access_token
			},
			timeout:30000,
			success:function(result,status,xhr){
				if(result.success){
					Sunjs.setLocalStorage(localstoragekey.userinfo,result.data);
					if(refresh){
						callback(result.data);
					}
				}else{
					Sunjs.error(result);
				}
			},
			error:function(xhr,type,error){
				if(type==='timeout'){
					plus.nativeUI.toast('请求超时,稍后重试');
					return;
				}
				if(xhr.status===401){
					Sunjs.error(JSON.parse(xhr.responseText));
					Sunjs.Logout();
				}else if(xhr.status===502){
					Sunjs.error(JSON.parse(xhr.responseText));
				}else{
					var _json=JSON.parse(xhr.responseText);
					plus.nativeUI.toast(_json.error);
				}
			}
		};
		
		mui.ajax(options);
	}
	//根据im账号获取用户信息
	Sunjs.getuserbyim=function(fromid,callback){
		var options={
			url:url.userinfo_im+fromid,
			dataType:config.datatype,
			headers:{
				'Authorization':config.bearer+' '+Sunjs.token().access_token
			},
			async:false,
			success:function(result,status,xhr){
				if(result.success){
					callback(result.data);
				}else{
					Sunjs.error(result);
				}		
			},
			error:function(xhr,type,error){
				console.log(url.userinfo_im+fromid);
				console.log(xhr.responseText);
			}
		};
		
		mui.ajax(options);
	}
	//存储LocalStorage
	Sunjs.setLocalStorage=function(key,value){
		if(typeof value ==='object'){
			value=JSON.stringify(value);
		}
		localStorage.setItem(key, value);
	}
	//获取LocalStorage type=json 或null
	Sunjs.getLocalStorage=function(key,type){
		var value=localStorage.getItem(key);
		return type==='json'?JSON.parse(value):value;
	}
	//删除key
	Sunjs.removeLocalStorage=function(key){
		localStorage.removeItem(key);
	}
	Sunjs.addSearchTemp=function(value){
		if(value===undefined || value==="")
			return;
		var searchTemp=plus.storage.getItem(localstoragekey.searchtemp);
		if(searchTemp===null){
			searchTemp=value;
			plus.storage.setItem(localstoragekey.searchtemp,searchTemp);
		}else{
			var _array=searchTemp.split(',');
			var _isbool=false;
			for(var i in _array){
				if(_array[i]===value){
					_isbool=true;
					break;
				}
			}
			if(!_isbool){
				if(_array.length>=7){
					searchTemp='';
					var _index=_array.length-6;
					for(var i=0;i<6;i++){
						searchTemp+=_array[i+_index]+',';
					}
					searchTemp+=value;
				}else{
					searchTemp+=','+value;
				}
				plus.storage.setItem(localstoragekey.searchtemp,searchTemp);
			}
		}
	}
	Sunjs.getSearchTemp=function(){
		var search=plus.storage.getItem(localstoragekey.searchtemp);
		return search;
	}
	
	Sunjs.clearSearchTemp=function(){
		plus.storage.removeItem(localstoragekey.searchtemp);
	}
	
	//发送验证码
	var wait=90;
	Sunjs.sendSms=function(tel,dom){
		if(tel=='' || tel==null || tel.length>20 || tel.length<11){
			plus.nativeUI.toast('请输入手机号');
			return;
		}
		Sunjs._sendSms(dom);
		plus.nativeUI.toast('验证码已发');
		Sunjs.ajaxGet(url.sms+tel,null,function(result){
			/*if(result.success){
				Sunjs._sendSms(dom);
				plus.nativeUI.toast('验证码已发');
			}else{
				plus.nativeUI.toast(result.error);
			}*/
		});
	}
	Sunjs._sendSms=function(dom){
		if (wait == 0) {
            dom.removeAttribute("disabled");           
            dom.value="发送验证码";
            wait = 90;
        } else {
            dom.setAttribute("disabled", true);
            dom.value="" + wait + "";
            wait--;
            setTimeout(function() {
                Sunjs._sendSms(dom);
            },1000);
        }
	}
	//获取hashcode
	Sunjs.hashcode=function(str){
		 return '123456';
	}
	/*
	 * 打开webview
	 */
	Sunjs.openview=function(url,id,styles,anishow,duration,showedcb){
		var _styles=styles||{
//			bounce:'vertical',
			popGesture:'close'
		};
		var _anishow=anishow||'pop-in';
		var _duration=duration||300;
		var _showedcb=showedcb||null;
		plus.webview.open( url, id, _styles, _anishow, _duration, _showedcb );
	}
	/*
	 * show webview窗体
	 */
	Sunjs.showview=function(obj,anishow,duration,showedcb){
		var _anishow=anishow||'pop-in';
		var _duration=duration||300;
		var _showedcb=showedcb||null;
		if(!obj){
			return;
		}
		obj.show(_anishow,_duration,_showedcb);
	}
	/*
	 * 根据窗口id显示
	 */
	Sunjs.showview_id=function(id,anishow,duration,showedcb){
		var _anishow=anishow||'pop-in';
		var _duration=duration||300;
		var _showedcb=showedcb||null;
		if(!id){
			return;
		}
		plus.webview.show(id,_anishow,_duration,_showedcb);
	}
	
	/*
	 * 下载文件
	 */
	Sunjs.download=function(url,callback){
		//下载图片并保存
		var _download=plus.downloader.createDownload(url,null,callback(download,status));
		_download.start();
	}
	
	/*
	 * ISO日期转换为本地日期
	 */
	Sunjs.ISODateFormat=function(date,format){
		if(!date){
			return '';
		}
		var _dt=new Date(date);
		//_dt=new Date(_tims);
		var map = {
	        "M": _dt.getMonth() + 1, //月份 
	        "d": _dt.getDate(), //日 
	        "h": _dt.getHours(), //小时 
	        "m": _dt.getMinutes(), //分 
	        "s": _dt.getSeconds(), //秒 
	        "q": Math.floor((_dt.getMonth() + 3) / 3), //季度 
	        "S": _dt.getMilliseconds() //毫秒 
	        };
	    format = format.replace(/([yMdhmsqS])+/g, function(all, t){
	        var v = map[t];
	        if(v !== undefined){
	            if(all.length > 1){
	                v = '0' + v;
	                v = v.substr(v.length-2);
	            }
	            return v;
	        }
	        else if(t === 'y'){
	            return (_dt.getFullYear() + '').substr(4 - all.length);
	        }
	        return all;
	    });
	    return format;
	}
	
	//设置图片
	Sunjs.setImg=function(element,url,default_ur){
		if(!element){
			return;
		}
		element.onload = function(){
			objImg.setAttribute('src',default_ur);
			objImg.onload = null;
		};
		element.onerror = function(){
			default_ur=default_ur||config.avatar;
			objImg.setAttribute('src',default_ur);//如果加载图片出现错误，给一个默认图片
		};
	}
	//通过IM账号获取头像和昵称
	Sunjs.getIM=function(uid){
		var _obj=Sunjs.getLocalStorage(localstoragekey.im_user+uid,'json');
		if(_obj){
			return _obj;
		}
		return null;
		/*
		Sunjs.getuserbyim(uid,function(result){
			_obj={
				avatar:result.avatar,
				nickname:result.nickname
			};
			Sunjs.setLocalStorage(localstoragekey.im_user+uid,_obj);
			return _obj;
		});*/
	}
	//错误通用处理方法
	Sunjs.error=function(obj){
		if(!obj){
			return;
		}
		if(typeof(obj)==='object'){
			if(obj.success){
				return;
			}
			if(obj.code){
				
			}
			plus.nativeUI.toast(obj.error);
			return;
		}
	}
	//获取设备信息
	Sunjs.device=function(){
		var info = plus.push.getClientInfo();
		var _device= {
			devcode:info.token,
			devmodel:plus.device.model,
			devsys:plus.os.name+'_'+plus.os.version+'_'+plus.os.language,
			token:info.token,
			clientid:info.clientid
		};
		return _device;
	}
	//创建消息提醒
	
	//获取访问令牌
	Sunjs.gettoken1=function(callback){
		try{
			var _appid='sunrise_member';
			var	_appsecret='e1d0b361201e4324b37c968fb71f0d3c';
			var _timestamp=Date.parse((new Date()).toUTCString())/1000;
			var _nonce=Math.round(Math.random()*10000);
			var _array=new Array(_nonce,_appsecret,_timestamp+'');
			_array.sort();
			var tmp=_array.join('');
			var _signature=md5(tmp).toUpperCase();
			var rq={
				appid:_appid,
				appsecret:_appsecret,
				timestamp:_timestamp,
				signature:_signature,
				nonce:_nonce
			};
			Sunjs.ajaxPost_Async(url.token1,JSON.stringify(rq),function(result){
				if(result.success){
					var _token={
						access_token:result.data.token,
						refresh_token:result.data.refresh_token,
						expires_in:result.data.expires_in,
						timestamp:_timestamp
					};
					Sunjs.removeLocalStorage(localstoragekey.token);
					Sunjs.setLocalStorage(localstoragekey.token,_token);
					//Sunjs.token=_token;
					callback&&callback(result.data);
				}else{
					Sunjs.error(result);
				}
			});
		}catch(ex){
			console.log(ex);
		}
	}
	//刷新访问令牌
	Sunjs.refreshtoken=function(){
		try{
			var _url=url.refreshtoken+Sunjs.token().refresh_token;
			var _timestamp=Date.parse((new Date()).toUTCString())/1000;
			console.log(Sunjs.token().refresh_token);
			Sunjs.ajaxPost_Async(_url,null,function(result){
				console.log(JSON.stringify(result));
				if(result.success){
					var _token={
						access_token:result.data.token,
						refresh_token:result.data.refresh_token,
						expires_in:result.data.expires_in,
						timestamp:_timestamp
					};
					Sunjs.setLocalStorage(localstoragekey.token,_token);
					console.log(JSON.stringify(_token));
					//Sunjs.token=_token;
				}else{
					Sunjs.error(result);
				}
			},true);
		}catch(ex){
			console.log(ex);	
		}
	}
	//获取用户头像和昵称 fid=用户编号
	Sunjs.getFriendInfo=function(fid){
		//获取好友信息
		var _values=plus.storage.getItem('friends'+Sunjs.user().id);
    	if(_values===null){
    		return null;
    	}
    	var _friends=JSON.parse(_values);
    	for(var j=0;j<_friends.length;j++){
			if(_friends[j].id+''===fid+''){
				return {
					nickname:_friends[j].nickname,
					avatar:_friends[j].avatar
				};
			}
		}
    	return null;
	}
	//推送本地消息
	Sunjs.push=function(content,payload,options){
		if((typeof payload)==='object'){
			payload=JSON.stringify(payload);
		}
		options=options||null;
		console.log(JSON.stringify(payload));
		plus.push.createMessage(content,payload,options);
	}
	//获取网络情况 true=无网络 false=有网络
	Sunjs.IsNet=function(){
		var nt= plus.networkinfo.getCurrentType();
		if (nt === plus.networkinfo.CONNECTION_NONE){
			return true;
		}
		return false;
	}
	//删除会话
	Sunjs.clearChat=function(uid){
		try{
			plus.storage.removeItem(localstoragekey.chathistory+'_'+Sunjs.user().id+'_u'+uid);
			var _sessions=Sunjs.getLocalStorage(localstoragekey.chatsession+'_'+Sunjs.user().id,'json');
			if(_sessions){
				for(var i in _sessions){
					if(_sessions[i].to==='u'+uid){
						_sessions.splice(i,1);
						break;
					}
				}
				Sunjs.setLocalStorage(localstoragekey.chatsession+'_'+Sunjs.user().id,_sessions);
			}
			//删除好友
			var _values=plus.storage.getItem('friends'+Sunjs.user().id);
	    	if(_values!==null){
	    		var _friends=JSON.parse(_values);
	    		for(var i=0;i<_friends.length;i++){
					if(_friends[i].id+''===uid+''){
						_friends.splice(i,1);
					}
				}
	    		plus.storage.setItem('friends'+Sunjs.user().id,JSON.stringify(_friends));
	    	}
	    	var _view=plus.webview.getWebviewById('message');
	    	if(_view){
	    		mui.fire(_view,'delete_uid',{id:uid});
	    	}
		}catch(ex){
			console.log(ex);
		}
	}
	//清空用户信息
	Sunjs.Logout=function(){
		try{
			//清空用信息
			Sunjs.removeLocalStorage(localstoragekey.userinfo);
			//清空会话列表
			Sunjs.removeLocalStorage(localstoragekey.chatsession);
			//token
			Sunjs.removeLocalStorage(localstoragekey.token);
			
			var _view=plus.webview.getWebviewById('personal');
			if(_view){
				_view.reload(true);
			}
		}catch(ex){
			console.log(ex);
		}
	}
	window.Sunjs=Sunjs;
	
})(window);
