/******************************
 * 
 * IM js
 * 
 ******************************/

var im=function(){
	//未读消息数
	var _unreads=0;
	
	var _conn = new Easemob.im.Connection({
		multiResources:false,
		https : true,
		url: config.im_url
	});
	
	_conn.listen({
		onOpened : function() {
	        curUserId = _conn.context.userId;
	        //查询好友列表
	        console.log('IM 服务开启');
	        getunreaders();
	        _conn.setPresence();
	        //启动心跳
			if (_conn.isOpened()) {
				_conn.heartBeat(conn);
			}
	    },
	    onClosed : function() {
	        //处理登出事件
	    },
	    //收到文本消息时的回调方法
	    onTextMessage : function(message){
	    	try{
		    	if(message.type==='error'){
		    		console.log('收到错误消息');
		    		return;
		    	}
		    	if(message.from==='admin'){
		    		handleSystemMessage(message);
		    		return;
		    	}
		    	var _values=plus.storage.getItem('friends'+Sunjs.user().id);
		    	if(_values===null){
		    		return;
		    	}
		    	var friends=JSON.parse(_values);
		    	var isFriend=false;
		    	for(var i=0;i<friends.length;i++){
		    		if('u'+friends[i].id===message.from.toLowerCase() || friends[i].name===message.to.toLowerCase() ){
		    			isFriend=true;
		    			break;
		    		}
		    	}
		    	if(isFriend){
		    		handleTextMessage(message);
		    	}
	    	}catch(ex){
	    		console.log(ex);
	    	}
	    	
	    },
	    //收到文本消息时的回调方法
	    
		//收到表情消息时的回调方法
		onEmotionMessage : function(message) {
			console.log(message);
		},
		//收到图片消息时的回调方法
		onPictureMessage : function(message) {
			console.log(message);
		},
		//收到音频消息的回调方法
		onAudioMessage : function(message) {
			console.log(message);
		},
		//收到位置消息的回调方法
		onLocationMessage : function(message) {
			console.log(message);
		},
		//收到文件消息的回调方法
		onFileMessage : function(message) {
			console.log(message);
		},
		//收到视频消息的回调方法
		onVideoMessage: function(message) {
			console.log(message);
		},
		//收到联系人订阅请求的回调方法
		onPresence: function(message) {
			console.log(message);
		},
		//收到联系人信息的回调方法
		onRoster: function(message) {
			console.log(message);
		},
		//收到群组邀请时的回调方法
		onInviteMessage: function(message) {
			//console.log(JSON.stringify(message));
		},
		//异常时的回调方法
		onError: function(message) {
			if(message.type===8 && message.msg==='conflict'){
				try{
					plus.nativeUI.showWaiting();
					Sunjs.ajaxPost(url.userlogout,null,function(result){
						if(result.success){
							Sunjs.removeLocalStorage(localstoragekey.userinfo);
							Sunjs.gettoken1(function(data){
								//刷新页面
								var subpages_id=['personal','message','right_main','shopping','relationship'];
								for(var i in subpages_id){
									var _view= plus.webview.getWebviewById(subpages_id[i]);
									if(_view!=null){
										_view.reload(true);	
									}
								}
								//清空会话列表
								Sunjs.removeLocalStorage(localstoragekey.chatsession);
								//获得主页面的webview
								var main = plus.webview.getLaunchWebview();
								mui.fire(main,eventkey.refresh_event,{type:'logout'});
								Sunjs.getById('msg').innerHTML='消息';
								plus.nativeUI.closeWaiting();
							});
						}else{
							Sunjs.error(result);
						}
					});
				}catch(ex){
					plus.nativeUI.closeWaiting();
					console.log(ex);
				}
				plus.nativeUI.alert('账号在其他地方登录',function(e){
				},'提示','确定');
			}
			console.log('IM 异常:'+JSON.stringify(message));
		}
	});
	
	//聊天会话列表 只负责更新会话
	//msgtype=消息类型 0=文本 1=图片 2=语音
	//fromid=发送者
	//to=接收者
	//chattype=聊天类型 单聊 群聊
	//data=消息字符串
	var _chatsession= function(msgtype,fromid,to,chattype,data,isself,ext){
		fromid=fromid.toLowerCase();
		to=to.toLowerCase();
		var __unreads=1;//未读消息数
		var _avatar='';//消息发送者头像
		var _tmpto=fromid.toLowerCase();//与谁聊天
		var _sessions=Sunjs.getLocalStorage(localstoragekey.chatsession+'_'+Sunjs.user().id,'json');
		
		if(chattype==='groupchat'){
			_tmpto=to;//为群聊时
		}else{
			_tmpto=isself==='1'?to:fromid;
		}
		if(_sessions==null ||_sessions==undefined ||_sessions.length==0){
			_sessions=[];
		}else{
			for(var i in _sessions){
				if(_sessions[i].to===_tmpto){
					var __obj=_sessions[i];//当前消息对象
					__unreads=__obj.unreads+1;
					//已存在会话列表则删除
					_sessions.splice(i,1);
					break;
				}
			}
		}
		var _msg={
			msgtype:msgtype,
			chattype:chattype,//单聊 群聊 聊天室
			to:_tmpto,//与谁聊天
			msg:data,
			stime:new Date(),
			unreads:isself==='1'?0:__unreads,//未读消息数
			status:0,//是否已读 0=未读 1=已读
			ext:ext
		};
		_sessions.push(_msg);
		//获取是否存在聊天页面 如果存在就无未读消息
		var __chat=plus.webview.getWebviewById('chat_'+_tmpto);

		if(__chat!==null){
			//存在就在返回页面的时候更新会话列表 未读消息数为0
			_sessions[_sessions.length-1].unreads=0;
		}
		
		//存储消息记录
		//存储会话列表
		Sunjs.setLocalStorage(localstoragekey.chatsession+'_'+Sunjs.user().id,_sessions);
		
		_updatesessionlist(_msg);
		//保存收到的消息
		_setchat(_tmpto,{
			self:isself||'0',
			from:fromid,
			to:to,
			msgtype:msgtype,
			chattype:chattype,
			msg:data,
			stime:(new Date()),
			ext:ext
		});
	}
	
	//存储消息记录对象
	var _setchat=function(id,value){
		var __array=_getchat(id);
		if(__array==null || __array.length==0){
			__array=[];
		}
		__array.push(value);
		plus.storage.setItem(localstoragekey.chathistory+'_'+Sunjs.user().id+'_'+id,JSON.stringify(__array));
	}
	//获取消息记录
	var _getchat=function(id){
		var tmp=plus.storage.getItem(localstoragekey.chathistory+'_'+Sunjs.user().id+'_'+id);
		return tmp==null?null:JSON.parse(tmp);
	}
	//更新会话列表
	var _updatesessionlist=function(msg){
		var __message = plus.webview.getWebviewById('message');
		//触发消息会话关系
		mui.fire(__message,eventkey.updatesession_event,{msg:msg});
		getunreaders();
	}
	
	this.init=function(id,pwd){
		_conn.open({
		    user : id,
		    pwd : pwd,
		    appKey : config.im_appkey//开发者APPKey
		});
	}
	//返回conn连接对象
	this.conn=function(){
		return _conn;
	}
	//关闭连接
	this.close=function(){
		_conn.close();
	}
	
	//自定义事件 消息发送
	document.addEventListener(eventkey.sendmsg_event, function(event) {
		try{
			var __msg=event.detail;
			console.log('----------开始发送消息:'+JSON.stringify(__msg));
			console.log('----------conn 链接状态：' +_conn.isOpened());
			if(__msg.msgtype==imkey.text_msg){
				//发送文本消息
				_conn.sendTextMessage({
					to:__msg.to,
					type:__msg.type,
					msg:__msg.msg,
					ext:__msg.ext
				});
			}else if(__msg.msgtype==imkey.audio_msg){
				//发送音频
				_conn.sendTextMessage({
					to:__msg.to,
					type:__msg.type,
					msg:__msg.msg,
					ext:{"msgtype":imkey.audio_msg}//扩展信息
				});
			}else if(__msg.msgtype==imkey.picture_msg){
				//发送图片
				_conn.sendTextMessage({
					to:__msg.to,//发送给谁
					type:__msg.type,//单聊 群聊
					msg:__msg.msg,//消息内容 图片音频为链接
					ext:{"msgtype":imkey.picture_msg}//扩展信息
				});
			}else{
				plus.nativeUI.toast('未知消息类型：'+__msg.msgtype);
				return;
			}
			
			console.log('---------发送消息完成:');
			var from='u'+Sunjs.user().id;
			//保存会话记录
			_chatsession(__msg.msgtype,from,__msg.to,__msg.type,__msg.msg,'1',__msg.ext);
		}catch(ex){
			console.log(ex);
		}
		
	});
	//自定义事件 更新会话列表
	document.addEventListener(eventkey.updatesession_event,function(){
		_updatesessionlist();
	});
	//自定义事件 更新首页tip
	document.addEventListener(eventkey.updatetip_event,function(event){
		var _sessions=Sunjs.getLocalStorage(localstoragekey.chatsession+'_'+Sunjs.user().id,'json');
		for(var i in _sessions){
			if(_sessions[i].from==event.detail.id || _sessions[i].to==event.detail.id){
				var _obj=_sessions[i];
				_obj.unreads=0;
				_sessions[i]=_obj;
				break;
			}
		}
		
		getunreaders();
	});
	//文本消息处理
	function handleTextMessage(message){
		try{
	    	var _to=message.from;
	    	var _msgtype='text';
	    	var _action=message.ext.action||'action';
	    	//判断消息类型
	    	if(message.type=='groupchat'){
	    		_to=message.to;	
	    	}
	    	//显示聊天信息
	    	var __chat = plus.webview.getWebviewById('chat_'+_to);
	    	if(message.ext){
				_msgtype=message.ext.msgtype||'text';
			}
	    	
			if(__chat!=null){
				//触发聊天页面chat
				mui.fire(__chat,eventkey.chat_event,{
					from: message.from,
					chattype: message.type,
					msg: message.data,
					msgtype:_msgtype,
					ext:message.ext
				});
			}
			if(Sunjs.getLocalStorage('appruntime')==='1'){
				//后台发送推送
				push.createpush(message.data,'',{
					title:'新消息',
					cover:true
				});
			}
			//更新会话列表
	    	_chatsession(_msgtype,message.from,message.to,message.type,message.data,'0',message.ext);
		}catch(ex){
			console.log('异常：'+ex);
		}	
	}
	//系统消息处理
	function handleSystemMessage(message){
		try{
			if(message.ext===null){
				console.log('未知消息:'+JSON.stringify(message));
				return;
			}
			var _user=Sunjs.user();
			var __unreads=1;//未读消息数
			var _tmpto='admin';

			var _sessions=Sunjs.getLocalStorage(localstoragekey.chatsession+'_'+_user.id,'json');
			if(_sessions==null ||_sessions==undefined ||_sessions.length==0){
				_sessions=[];
			}else{
				for(var i in _sessions){
					if(_sessions[i].to===_tmpto){
						var __obj=_sessions[i];//当前消息对象
						__unreads=__obj.unreads+1;
						//已存在会话列表则删除
						_sessions.splice(i,1);
						break;
					}
				}
			}
			var _msg={
				msgtype:'text',
				chattype:message.chattype,//单聊 群聊 聊天室
				to:_tmpto,//与谁聊天
				msg:message.data,
				stime:new Date(),
				unreads:__unreads,//未读消息数
				status:0//是否已读 0=未读 1=已读
			};
			//保存会话
			_sessions.push(_msg);
			Sunjs.setLocalStorage(localstoragekey.chatsession+'_'+_user.id,_sessions);
			console.log('--------------'+JSON.stringify(_msg));
			//更新message 会话列表
			_updatesessionlist(_msg);
			//发送推送消息
			for(var i in push_action){
				if(message.ext.action===push_action[i]){
					Sunjs.push(message.data,_msg);
					break;	
				}
			}
			//保存系统消息
			var _syss=plus.storage.getItem(localstoragekey.sys_message+_user.id);
			var _sysobj=[];
			var _action=message.ext.action||'action';
			if(_syss!==null){
				_sysobj=JSON.parse(_syss);
				for(var i in _sysobj){
					if(_sysobj[i].action===_action){
						var __obj=_sysobj[i];//当前消息对象
						__unreads=__obj.unreads+1;
						//已存在会话列表则删除
						_sysobj.splice(i,1);
						break;
					}
				}
			}
			var _sysmsg={
				action:_action,
				msg:message.data,
				stime:new Date(),
				unreads:__unreads,//未读消息数
				status:0//是否已读 0=未读 1=已读
			};
			if(message.ext.action==='allowfriends'){
				//关系关心页面
				var _view=plus.webview.getWebviewById('relationship');
				mui.fire(_view,'refreshfriends',null);
			}
			//保存会话
			_sysobj.push(_sysmsg);
			plus.storage.setItem(localstoragekey.sys_message+_user.id,JSON.stringify(_sysobj));
			console.log(JSON.stringify(_sysobj));
		}catch(ex){
			console.log('异常：'+ex);
		}
	}
	//更新消息提示
	function getunreaders(){
		var _sessions=Sunjs.getLocalStorage(localstoragekey.chatsession+'_'+Sunjs.user().id,'json');
		if(_sessions===null ||_sessions.length===0){
			return;
		}
		var _count=0;
		for(var i in _sessions){
			_count+=_sessions[i].unreads;
		}
		if(_count==0){
			Sunjs.getById('msg').innerHTML='消息';
		}else{
			Sunjs.getById('msg').innerHTML='消息<i>'+_count+'</i>';
		}
	}
};

var _im=new im();
//_im.init();
