/************************************
 *
 * message js
 * 
 ************************************/

;(function($){
	$.init();
	
	$.plusReady(function(){
		try{
			Sunjs.init();
			template.config('escape', false);
			if(!Sunjs.getLocalStorage(localstoragekey.lauchFlag)){
				Sunjs.getById('sessions').innerHTML='<li class="mui-table-view-cell sw-rel-list"><div class="mui-slider-handle"><a><img src="../../images/sunriselogo.jpg" /></a><div class="sw-mes-Tits"><p>欢迎使用日上会员APP</p></div></div></li>';		
			}
			//Sunjs.removeLocalStorage(localstoragekey.chatsession+'_'+Sunjs.user().id);
			//slider();
			if(Sunjs.user()!==null){
				getsessions();
				//判断是否已登录 判断是否已存在会话列表	
				sessions();
			}
			
			Sunjs.getById('news_list').addEventListener('tap',function(){
				Sunjs.openview('news.html','news_list');
			});
			
			Sunjs.ajaxGet(url.gettop,null,function(result){
				if(result.success && result.data!=null){
					Sunjs.getById('news_top').innerHTML=result.data;
				}
			});
		}catch(ex){
			console.log(ex);
		}
		
	});
	
	//获取会话列表
	function getsessions(){
		var _tmp=Sunjs.getLocalStorage(localstoragekey.chatsession+'_'+Sunjs.user().id,'json');
		if(_tmp===null || _tmp.length==0){
			Sunjs.ajaxGet(url.usersessions,null,function(result){
				if(result.success){
					Sunjs.getById('sessions').innerHTML=template('sessions_tmp',{record:result.data});
					//保存消息列表
				}else{
					Sunjs.error(result);
				}
			});
		}else{
			var _array=_tmp.reverse();
			var _friends=JSON.parse(plus.storage.getItem('friends'+Sunjs.user().id));
			for(var i=0;i<_array.length;i++){
				if(_array[i].to==='admin'){
					_array[i].nickname='系统';
				}else{
					for(var j=0;j<_friends.length;j++){
						if(_array[i].chattype=='groupchat'){
							if(_friends[j].name===_array[i].to){
								_array[i].nickname=_friends[j].nickname;
								_array[i].avatar=_friends[j].avatar;
							}
						}else{
							if('u'+_friends[j].id===_array[i].to){
								_array[i].nickname=_friends[j].nickname;
								_array[i].avatar=_friends[j].avatar;
							}
						}
						
					}
				}
			}

			Sunjs.getById('sessions').innerHTML=template('sessions_tmp',{record:_array});
			mui('#sessions img').each(function(){
				loadimg(this);
			});
		}
		
	}
	//注册事件
	function sessions(){
		$('#sessions').on('tap','.sw-rel-list',function(){
			var id=this.getAttribute('data-id');
			var name=this.getAttribute('data-name');
			var chattype=this.getAttribute('data-type');
			
			//更新当前消息数
			var _em=this.getElementsByTagName('em');
			if(_em.length>0){
				var _array=Sunjs.getLocalStorage(localstoragekey.chatsession+'_'+Sunjs.user().id,'json');
				for(var i=0;i<_array.length;i++){
					if(_array[i].to===id){
						_array[i].unreads=0;
						Sunjs.setLocalStorage(localstoragekey.chatsession+'_'+Sunjs.user().id,_array);
						break;
					}
				}
				this.getElementsByTagName('i')[0].removeChild(_em[0]);
			}
			//获得主页面的webview
			var main = plus.webview.getLaunchWebview();
			//更新消息tip
			$.fire(main, eventkey.updatetip_event,{});
			if(id==='admin'){
				Sunjs.openview('sysmessage.html','sysmessage');
				return;
			}
			
			Sunjs.setLocalStorage('chatid',id);
			Sunjs.setLocalStorage('chatname',name);
			Sunjs.setLocalStorage('chattype',chattype);
			
			Sunjs.openview('../../pages/message/message_chat.html','chat_'+id);
			
		});
		$('#sessions').on('tap','.mui-btn-red',function(){
			var _id=this.getAttribute('data-id');
			var _array=Sunjs.getLocalStorage(localstoragekey.chatsession+'_'+Sunjs.user().id,'json');
			for(var i=0;i<_array.length;i++){
				if(_array[i].to===_id){
					_array.splice(i,1);
					//保存会话列表
					Sunjs.setLocalStorage(localstoragekey.chatsession+'_'+Sunjs.user().id,_array);
					//删除当前页
					var _li= this.parentNode.parentNode;
					if(_li){
						Sunjs.getById('sessions').removeChild(_li);
					}
					//删除聊天
					plus.storage.removeItem(localstoragekey.chathistory+'_'+Sunjs.user().id+'_'+_id);
					break;
				}
			}
			
		});
	}
	
	//自定义事件 更新会话列表
	document.addEventListener(eventkey.updatesession_event, function(event) {
		try{
			//不存在会话新建一个会话并顶置
			var _u=null;
			var _msg=event.detail.msg;
			var _ul=Sunjs.getById('sessions');
			var _li=Sunjs.getById(_msg.to);
			//获取好友信息
			var _values=plus.storage.getItem('friends'+Sunjs.user().id);
	    	if(_values===null && _msg.to!=='admin'){
	    		return;
	    	}
	    	if(_values===null && _msg.to==='admin'){
	    		_values='{}';
	    	}
	    	var friends=JSON.parse(_values);
			if(_li){
				if(_msg.to==='admin'){
					_u={
						nickname:'系统'
					}
				}
		    	for(var i=0;i<friends.length;i++){
		    		if(_msg.chattype==='groupchat'){
		    			if(friends[i].name===_msg.to){
							_u=friends[i];
							break;
						}
		    		}else{
		    			if('u'+friends[i].id==_msg.to.toLowerCase()){
			    			_u=friends[i];
			    			break;
			    		}
		    		}	
		    	}
		    	_msg.nickname=_u.nickname;
		    	_msg.avatar=_u.avatar;
				_li.innerHTML=template('session_tmp',{item:_msg});
				loadimg(_li.getElementsByTagName('img')[0]);
				_ul.insertBefore(_li,_ul.childNodes[0]);
			}else{
				if(_msg.to==='admin'){
					_u={
						nickname:'系统'
					}
					_li=document.createElement('li');
					_li.setAttribute('class','mui-table-view-cell sw-rel-list colors2');
					_li.setAttribute('id',_msg.to);
					_li.setAttribute('data-id',_msg.to);
					_li.setAttribute('data-name',_u.nickname);
					_li.setAttribute('data-type',_msg.chattype);
					_li.innerHTML=template('session_tmp',{item:_msg});
					loadimg(_li.getElementsByTagName('img')[0]);
					_ul.insertBefore(_li,_ul.childNodes[0]);
				}else{
					var _color=_msg.chattype==='chat'?'colors3':'colors4';
					//获取好友信息
			    	for(var i=0;i<friends.length;i++){
			    		if(_msg.chattype==='groupchat'){
			    			if(friends[i].name===_msg.to.toLowerCase()){
								_u=friends[i];
								break;
							}
			    		}else{
			    			if('u'+friends[i].id===_msg.to.toLowerCase()){
				    			_u=friends[i];
				    			break;
				    		}
			    		}
			    	}
			    	if(_u===null){
			    		console.log('好友不存在');
			    		return;
			    	}
			    	_li=document.createElement('li');
					_li.setAttribute('class','mui-table-view-cell sw-rel-list '+_color);
					_li.setAttribute('id',_msg.to);
					_li.setAttribute('data-id',_msg.to);
					_li.setAttribute('data-name',_u.nickname);
					_li.setAttribute('data-type',_msg.chattype);
					_msg.avatar=_u.avatar;
					_msg.nickname=_u.nickname;
					console.log(JSON.stringify(_msg));
					_li.innerHTML=template('session_tmp',{item:_msg});
					loadimg(_li.getElementsByTagName('img')[0]);
					_ul.insertBefore(_li,_ul.childNodes[0]);
				}
			}
		}catch(ex){
			console.log(ex);
		}
	});
	//设置头像
	document.addEventListener('updateavatar',function(event){
		var _details=event.detail.detail;
		for(var i in _details){
			var _item=_details[i];
			var _tmp=Sunjs.getById('u'+_item.id);
			if(_tmp===null ||_tmp===undefined)
				continue;
			
			var _img=Sunjs.getById('img_u'+_item.id);
			if(_img.getAttribute('data-lazyload')===_item.avatar){
				continue;
			}
			if(_item.avatar===''){
				_img.setAttribute('src','../../images/default_avatar.jpg');
			}else{
				_img.setAttribute('src',_item.avatar);
			}
			var _sessions=Sunjs.getLocalStorage(localstoragekey.chatsession+'_'+Sunjs.user().id,'json');
			for(var i in _sessions){
				var _ss=_sessions[i];
				if(_ss.to==='u'+_item.id){
					_ss.avatar=_item.avatar;
				}
			}
			Sunjs.setLocalStorage(localstoragekey.chatsession+'_'+Sunjs.user().id,_sessions);
		}
	});
	//删除指定用户会话
	document.addEventListener('delete_uid',function(event){
		var _id=event.detail.id;
		//删除元素
		var _li=Sunjs.getById('u'+_id);
		if(_li){
			Sunjs.getById('sessions').removeChild(_li);
		}
	});
	//刷新会话列表
	document.addEventListener('refresh_sessions',function(event){
		getsessions();
	});
	//获取昵称和头像
	template.helper('av_nick',function(uid){
		if(uid==='admin'){
			return {
				nickname:'系统消息',
				avatar:''
			};
		}
		return Sunjs.getIM(uid);
	});
	template.helper('dateformat',function(date){
		if(!date){
			return '';
		}
		var _date=new Date(date);
		var _times=_date.getTime();//获取毫秒数
		var _now=new Date();//当前毫秒数
		var _tp=_now.getTime()-_times;
		var _onedays=24*60*60*1000;//一天
		
		//先判断是否为同一天
		if(_date.getFullYear()===_now.getFullYear() && _date.getMonth()===_now.getMonth() && _date.getDate()===_now.getDate()){
			return Sunjs.ISODateFormat(date,'hh:mm');
		}
		if(_date.getFullYear()===_now.getFullYear()){
			if(_date.getMonth()===_now.getMonth() && _date.getDate()+1===_now.getDate()){
				return '昨天';
			}
			var _tmpdate=_date.setDate(_date.getDate()+1);
			_tmpdate=new Date(_tmpdate);
			if(_tmpdate.getMonth()===_now.getMonth() && _tmpdate.getDate()==_now.getDate()){
				return '昨天';
			}
		}
		return Sunjs.ISODateFormat(date,'yyyy-MM-dd');
	});
})(mui);
