

var ShoppingManager={
	Init:function(){
		//加载商品列表信息
		ShoppingManager.GetList();

		//绑定搜索按钮事件
		mui(".sw-ShoppingLinks2").on("tap","a.sw-spser",function(event){
			var _view = plus.webview.create('shopping2.html', 'shopping2');
			Sunjs.showview(_view);
		});
		//分类聚焦
		mui(".sw-ShoppingLinks2").on("tap","a.sw-splist",function(event){
			var _view = plus.webview.create('shopping_category_focus.html', 'shopping_category_focus');
			Sunjs.showview(_view);
		});
	},
	SetList:function(result){
		if (result!=undefined && result.success == true) {
			var resultList = result.data;
			var html="";
			if(resultList!=undefined && resultList.length>0){
				for (var i = 0;i<resultList.length;i++) {
					var item=resultList[i];
					html+='<li class="sw-rel-list">';
						html+="<a id='"+item.abiid+"'>";
							html+="<img data-lazyload='"+item.img_url+"' src='../../images/default_img.jpg'/>";
							//html+="<img src='"+item.img_url+"' />";
							html+="<span>"+item.mainname+"</span>";
							html+="<span class=\"ens\">"+item.subtitle+"</span>";
							html+="<b>&yen;"+item.price+"</b>";
						html+="</a>";
					html+='</li>';
				}
			}
			Sunjs.getById("list-hotProsList").innerHTML=html;
			if(html.length>0){
				//渲染图片懒加载
				ShoppingManager.RenderImage();
			}

			//绑定事件操作
			ShoppingManager.BindEvent();
		}
	},
	RenderImage:function(){
		//渲染图片懒加载
		mui('#list-hotProsList img').each(function(index, el) {
			loadimg(this);
		});
	},
	GetList:function(){
		Sunjs.ajaxGet(url.topgoods+'1', null, function(result) {
			ShoppingManager.SetList(result);
		}); 
	},
	BindEvent:function(){

		//绑定事件 打开详细页面
		mui('#list-hotProsList').on("tap","a",function(event){
			var id = this.getAttribute('id');
			var _view = plus.webview.create('shopping_product_details.html', 'shopping_product_details');

			//触发自定义事件
			_view.addEventListener('loaded',function () {
			    mui.fire(_view,eventkey.goodsdetail_event,{id:id});
				Sunjs.showview(_view);
			});
		});
	}
}

mui.plusReady(function(){
	Sunjs.init();
	ShoppingManager.Init();
	GetServerCart();
});
var openShopCar=function(){
	Sunjs.openview("shopping_cart.html","shopping_cart");
};
var GetServerCart=function(){
	if(Sunjs.user()!=null && Sunjs.user()!=undefined){
		Sunjs.ajaxGet(url.shopcart,null,function(result){
			if(result.success==true){
				var count=0;
				Sunjs.getById("productcount").style.display="none";
				if(result.data==null || result.data.length==0){
					Sunjs.getById("productcount").innerHTML=0;
					return;
				}
				Sunjs.getById("productcount").style.display="block";
				for(var i=0;i<result.data.length;i++){
					count+=result.data[i].num;
				}
				Sunjs.getById("productcount").innerHTML=count;
			}
			else{
				Sunjs.error(result);
			}
		});
	}
};