mui.init({

});
Sunjs.init();

mui.plusReady(function() {
	var record = [{}];
	var ui = {
		list: Sunjs.getById("list-hotProsList")
	};

	if (Sunjs.getById("searchhotskey") == undefined) {
		goods();
	} else {
		Sunjs.ajaxGet_wait(url.topgoods, null, function(data) {
			if (data.success == true) {
				loadGoods(data);
			}
		}); 
	}

	if (Sunjs.user != null && Sunjs.user != undefined && Sunjs.getById("productcount") != undefined) {

		Sunjs.ajaxGet_wait(url.shopcart, null, function(result) {
			if (result.success == true) {
				console.log("获取购物车成功");
				var count = 0;
				for (var i = 0; i < result.data.length; i++) {
					count += result.data[i].num;
				}
				Sunjs.getById("productcount").innerHTML = count;
			} else {
				console.log("获取购物车失败");
			}
		});
	}

	//加载产品信息
	function loadGoods(data){
		if (data.success == true) {
			var resultList = data.data;
			console.log("获取商品列表");
			console.log(JSON.stringify(resultList));
			
			var html="";
			if(resultList!=undefined && resultList.length>0){
				for (var i = 0;i<resultList.length;i++) {
					var item=resultList[i];
					html+='<li class="sw-rel-list">';
						html+="<a id='"+item.abiid+"'>";
							html+="<img data-lazyload='"+item.img_url+"' src='../../images/default_img.jpg'/>";
							html+="<span>"+item.mainname+"</span>";
							html+="<span class=\"ens\">"+item.subtitle+"</span>";
							html+="<b>&yen;"+item.price+"</b>";
						html+="</a>";
					html+='</li>';
				}
			}
			mui('#pullrefresh').pullRefresh().endPullupToRefresh(true);
			ui.list.innerHTML = html;
			
			
			//图片延迟加载,并且将图片缓存到本地
			mui('#pullrefresh img').each(function(index, el) {
				loadimg(this);
			});
		}
	}

	function goods() {
		Sunjs.ajaxGet(url.hotgoods, null, function(data) {
			loadGoods(data);
		});
	}

	//页面更新事件
	document.addEventListener(eventkey.refresh_event, function(event) {
		goods();
	});
});

var bindList = function() {
	ui.list.innerHTML = template('list-template', {
		"record": record
	});
};
mui('.sw-hotProsList').on('tap', 'a', function() {
	var id = this.getAttribute('id');
	console.log(this.getAttribute('id'));
	var _view = plus.webview.create('shopping_product_details.html', 'goods_detail');
	_view.addEventListener('loaded', function() {
		mui.fire(_view, eventkey.goodsdetail_event, {
			id: id
		});
		Sunjs.showview(_view);
	});
});

mui('.sw-ShoppingLinks2').on('tap', 'a', function(e) {
	var href = this.getAttribute('href');
	//Sunjs.openview(href,href);
	var _styles = {

	};
	var _anishow = 'pop-in';
	var _duration = 300;
	var _showedcb = null;
	plus.webview.open(href, href, _styles, _anishow, _duration, _showedcb);
});


mui('.sw-ShoppingLinks').on('tap', 'a', function(e) {
	var href = this.getAttribute('href');
	Sunjs.openview(href, href);
});

mui('.sw-Shopping-search').on('tap', 'i', function(e) {
	var searchkey = Sunjs.getById("searchkey").value;
	Sunjs.addSearchTemp(searchkey);

	var _view = plus.webview.create('shopping_product_list.html', 'shopping_product_list');
	_view.addEventListener('loaded', function() {
		mui.fire(_view, eventkey.productlist_event, {
			searchkey: searchkey
		});
		Sunjs.showview(_view);
	});
});
//热门搜索
mui('.swRmLists').on('tap', 'a', function(e) {
	var searchkey = this.innerHTML;
	var newsdetail = plus.webview.create('shopping_product_list.html', 'shopping_product_list.html');
	mui.fire(newsdetail, eventkey.productlistadvanced_envent, {
		searchkey: searchkey,
		brandid: 0,
		categoryid: 0
	});
	Sunjs.showview(newsdetail);
});
